import { FormatResult } from 'farrow-api/dist/toJSON';
import { CodegenOptions } from 'farrow-api/dist/codegen';
export type ApiClientOptions = {
    /**
     * http address of farrow-api
     */
    src: string;
    /**
     * file address of codegen target
     */
    dist: string;
    /**
     * introspection url
     * default value is /__introspection__
     * if you want to use another url, you can set it here
     */
    introspectionUrl?: string;
    /**
     * get introspection from server
     */
    getIntropection?: (body: unknown) => Promise<FormatResult>;
    /**
     * codegen options
     */
    codegen?: CodegenOptions;
    /**
     * the interval of polling
     * default value is 3000ms
     */
    pollingInterval?: number;
    /**
     * logger options for polling
     */
    logger?: false | ((options: ApiClientOptions) => void);
};
export declare const createApiClient: (options: ApiClientOptions) => {
    sync: () => Promise<void>;
    start: () => void;
    stop: () => void;
};
export type CreateApiClientsOptions = {
    services: ApiClientOptions[];
};
export declare const createApiClients: (options: CreateApiClientsOptions) => {
    sync: () => Promise<void>;
    start: () => void;
    stop: () => void;
};
