"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var server_1 = require("../bundler/server");
var api_client_1 = require("../api-client");
var config_1 = require("../config");
function dev(options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var config, serversOptions, bundlers, serverBundlers, apiClientsOptions, client;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, config_1.getConfig)(options)];
                case 1:
                    config = _a.sent();
                    serversOptions = config.server ? (Array.isArray(config.server) ? config.server : [config.server]) : [];
                    if (!(serversOptions.length > 0)) return [3 /*break*/, 3];
                    bundlers = serversOptions.map(function (options) {
                        return tslib_1.__assign({ env: {
                                NODE_ENV: 'development',
                            } }, options);
                    });
                    serverBundlers = (0, server_1.createServerBundlers)({ bundlers: bundlers });
                    return [4 /*yield*/, serverBundlers.start({
                            build: true,
                            watch: true,
                            run: true,
                        })];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    apiClientsOptions = config.api ? (Array.isArray(config.api) ? config.api : [config.api]) : [];
                    if (apiClientsOptions.length > 0) {
                        client = (0, api_client_1.createApiClients)({
                            services: apiClientsOptions,
                        });
                        client.start();
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = dev;
//# sourceMappingURL=dev.js.map